# -*- coding: utf-8 -*-
##############################################################################
#
#    Email marketing click & read tracker
#    Copyright (C) 2011 Florent Aide, <florent.aide@gmail.com>
#    Copyright (C) 2011 XCG Consulting (http://www.xcg-consulting.fr/)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import osv, fields
from replace import insert_tracker_in_html, insert_tracker_in_text

class hooked_email_template(osv.osv):
    """overrides the base email template to hook the URL tracker
    """
    _inherit = 'email.template'

    print 'hooked_email_template'

    def add_tracker_in_mail(self, values, context=None):

        print values.body_text
        print values.body_html

        # CHANGE FROM ORIGINAL METHOD

        print values.body_text
        print values.body_html

        return values


    def send_mail(self, cr, uid, template_id, res_id, context=None):
        """Generates a new mail message for the given template and record,                                                                                                                                                  and schedule it for delivery through the ``mail`` module's scheduler.                                                                                                                                 

           :param int template_id: id of the template to render                                                                                                                                                             :param int res_id: id of the record to render the template with                                                                                                                                                                     (model is taken from the template)                                                                                                                                                         """
        print 'DEBUG send_mail XCG'
        mail_message = self.pool.get('mail.message')
        ir_attachment = self.pool.get('ir.attachment')
        template = self.browse(cr, uid, template_id, context)
        values = self.generate_email(cr, uid, template_id, res_id, context=context)
        if context.get('use_tracker', False):
            # here we need to use tracker so let's do it
            tracker_base = context.get('tracker_base')
            if values['body_text']:
                print values['body_text']
                values['body_text'], tracks = insert_tracker_in_text(
                    values['body_text'], 
                    tracker_base, 
                    context['activity_id'])
                print values['body_text']
            if values['body_html']:
                print values['body_html']
                values['body_html'], tracks = insert_tracker_in_html(
                    values['body_html'],
                    tracker_base, 
                    context['activity_id'])
                print values['body_html']

            print 'DEBUG 1'
            trackitem = self.pool.get('marketing_campaign_tracker.trackitem')
            print 'DEBUG 2'
            print trackitem
            print dir(trackitem)
            for trackvalues in tracks:
                print trackvalues
                # create a trackitem for each URL that is replaced
                print 'DEBUG 3'
                trackitem.create(cr, uid, trackvalues, context=None)
            print 'DEBUG 4'

        #values = self.add_tracker(cr, uid, template_id, res_id, context=context)
        attachments = values.pop('attachments') or {}
        message_id = mail_message.create(cr, uid, values, context=context)
        # link attachments

        attachment_ids = []
        for fname, fcontent in attachments.iteritems():
            attachment_data = {
                'name': fname,
                'datas_fname': fname,
                'datas': fcontent,
                    'res_model': mail_message._name,
                'res_id': message_id,
                }
            if context.has_key('default_type'):
                del context['default_type']
            attachment_ids.append(ir_attachment.create(cr, uid, attachment_data, context))

hooked_email_template()


class marketing_campaign_activity(osv.osv):
    # we want to change the marketing campaign activity...
    _inherit = 'marketing.campaign.activity'

    # here we add a new field to the marketing campaign activity
    # the use_tracker boolean will activate the tracking for URLs if is
    # set to True. The default value will be False in order to avoid any
    # problem with existing activities previous to this module installation.
    _columns = {
        'use_tracker': fields.boolean('Use Tracker',
                help='This option activates the usage of the external "Bounced" click tracker'),
        'tracker_base': fields.char("Tracker Base URL", size=200,
                help="The base URL on which the tracker listens"),
        }

    # make sure our new field has a sensible default.
    # see comment above the _columns definition for more
    _defaults = dict(
        use_tracker = False,
        tracker_base = None,
    )

    # make sure an activity which uses a tracker always has a tracker
    # base defined...
    def _check_baseurl(self, cr, uid, ids, context=None):
        """Validates that every activity which has the use_tracker option set
        also has a tracker_base defined
        """
        activities = self.browse(cr, uid, ids, context=context)

        for activity in activities:
            if activity.use_tracker and not activity.tracker_base:
                return False

        return True

    _constraints = [
        (_check_baseurl,
        'If you activate tracking you must give a tracker base',
        ['tracker_base'])
    ]

    # override the _process_wi_email to replace all the URLs in the template
    # body by our tracker URL and store the corresponding keys in database
    def _process_wi_email(self, cr, uid, activity, workitem, context=None):
        if context is None:
            context = {}

        context['use_tracker'] = activity.use_tracker

        if activity.use_tracker:
            # remove any trailing slash that could be present in the base_url
            context['tracker_base'] = activity.tracker_base.rstrip('/')
            context['activity_id'] = activity.id

        return self.pool.get('email.template').send_mail(cr, uid,
                                            activity.email_template_id.id,
                                            workitem.res_id, context=context)
        

marketing_campaign_activity()


# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

